<template>
  <v-form ref="formMisiones" v-model="valid">
    <v-card>
      <v-card-title class="headline pl-5 primary white--text" primary-title>
        {{ $t('titleuploadata') }}
      </v-card-title>
      <v-divider></v-divider>
      <v-card-text class="my-3 px-5">
        <v-row>
          <v-col cols="12">
            <strong>Expediente Nº:</strong>
            <v-divider class="mt-3"></v-divider>
          </v-col>
          <v-col cols="12" xs="12" sm="4" md="4" class="pr-1">
            <v-text-field
              v-model="certificado.code"
              label="Código organismo *"
              type="number"
              outlined
              required
              :rules="rules.concat(rulesNumber4)"
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="3" md="3" class="px-1">
            <v-text-field
              v-model="certificado.correlative"
              label="Nº Correlativo *"
              type="number"
              outlined
              required
              :rules="rules.concat(rulesNumber3)"
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="2" md="2" class="px-1">
            <v-text-field
              v-model="certificado.year"
              :rules="rules.concat(rulesNumber4)"
              label="Año *"
              required
              outlined
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="3" md="3" class="pl-1">
            <v-text-field
              v-model="certificado.body"
              label="Cuerpo Nº *"
              type="number"
              outlined
              required
              :rules="rules.concat(rulesNumber1)"
            ></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" class="pt-0">
            <strong>Informe técnico No.:</strong>
            <v-divider class="mt-3"></v-divider>
          </v-col>
          <v-col cols="12" xs="12" sm="6" md="6">
            <v-text-field
              v-model="certificado.technical_report"
              label="Número de informe *"
              type="number"
              outlined
              required
              :rules="rules.concat(rulesNumber4)"
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="6" md="6" class="px-1">
            <v-text-field
              v-model="certificado.technical_report_year"
              :rules="rules.concat(rulesNumber4)"
              label="Año *"
              required
              outlined
            ></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" class="pt-0">
            <strong>Disposición:</strong>
            <v-divider class="mt-3"></v-divider>
          </v-col>
          <v-col cols="12" sm="6" md="6" class="pr-1">
            <v-text-field
              v-model="certificado.disposition"
              label="Número de Disposición *"
              type="number"
              outlined
              required
              :rules="rules"
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="6" md="6">
            <v-dialog
              ref="dialogDate"
              v-model="modalSelectDate"
              :return-value.sync="certificado.date"
              :rules="rules"
              persistent
              width="290px"
            >
              <template #activator="{ on }">
                <v-text-field
                  v-model="certificado.date"
                  :rules="rules"
                  label="Fecha *"
                  readonly
                  required
                  outlined
                  v-on="on"
                ></v-text-field>
              </template>
              <v-date-picker
                v-model="certificado.date"
                :locale="$i18n.locale"
                scrollable
                required
              >
                <v-spacer></v-spacer>
                <v-btn color="primary" @click="modalSelectDate = false">
                  Cancelar
                </v-btn>
                <v-btn
                  color="primary"
                  @click="$refs.dialogDate.save(certificado.date)"
                >
                  Aceptar
                </v-btn>
              </v-date-picker>
            </v-dialog>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" class="pt-0">
            <strong>Informe Catastral / ID GIS:</strong>
            <v-divider class="mt-3"></v-divider>
          </v-col>
          <v-col cols="12" xs="12" sm="4" md="4" class="pr-1 pb-0">
            <v-text-field
              v-model="certificado.office_department"
              label="Departamento *"
              type="number"
              outlined
              required
              :rules="rules.concat(rulesNumber2)"
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="4" md="4" class="pr-1 pb-0">
            <v-text-field
              v-model="certificado.municipality"
              :rules="rules.concat(rulesNumber2)"
              label="Municipio *"
              required
              outlined
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="4" md="4" class="pr-1 pb-0">
            <v-text-field
              v-model="certificado.section"
              label="Sección *"
              type="number"
              outlined
              required
              :rules="rules.concat(rulesNumber3)"
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="4" md="4" class="pr-1">
            <v-text-field
              v-model="certificado.chacra"
              :rules="rules.concat(rulesNumber4)"
              label="Chacra *"
              required
              outlined
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="4" md="4" class="pr-1">
            <v-text-field
              v-model="certificado.apple"
              label="Manzana *"
              type="number"
              outlined
              required
              :rules="rules.concat(rulesNumber4)"
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="4" md="4">
            <v-text-field
              v-model="certificado.parcela"
              :rules="rules.concat(rulesNumber4)"
              label="Parcela *"
              required
              outlined
            ></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" class="pt-0">
            <strong>Profesional a Cargo:</strong>
            <v-divider class="mt-3"></v-divider>
          </v-col>
          <v-col cols="12" xs="12" sm="8" md="8" class="pr-1">
            <v-text-field
              v-model="certificado.initiator_name"
              :rules="rules"
              label="Apellido y Nombre *"
              required
              outlined
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="4" md="4">
            <v-text-field
              v-model="certificado.initiator_dni"
              :rules="rules"
              label="D.N.I *"
              required
              outlined
            ></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" class="pt-0">
            <strong>Solicitante:</strong>
            <v-divider class="mt-3"></v-divider>
          </v-col>
          <v-col cols="12" xs="4" sm="4" md="4" class="pr-1 pb-0">
            <v-autocomplete
              v-model="certificado.kind_of_person"
              :items="kindofperson"
              label="Tipo de persona *"
              required
              :rules="rules"
              outlined
            ></v-autocomplete>
          </v-col>
          <v-col cols="12" xs="12" sm="8" md="8" class="pb-0">
            <v-text-field
              v-model="certificado.applicant_name"
              :rules="rules"
              :label="
                certificado.kind_of_person === 'Física'
                  ? 'Apellido y Nombre *'
                  : 'Empresa *'
              "
              required
              outlined
            ></v-text-field>
          </v-col>
          <v-col cols="12" xs="12" sm="4" md="4" class="pr-1">
            <v-text-field
              v-model="certificado.applicant_dni"
              :rules="rules"
              type="number"
              :label="
                certificado.kind_of_person === 'Física' ? 'D.N.I *' : 'CUIT *'
              "
              required
              outlined
            ></v-text-field>
          </v-col>
          <template v-if="certificado.kind_of_person === 'Física'">
            <v-col cols="12" xs="12" sm="4" md="4" class="pr-1">
              <v-text-field
                v-model="certificado.applicant_caracter"
                :rules="rules"
                label="Caracter"
                required
                outlined
              ></v-text-field>
            </v-col>
            <v-col cols="12" xs="12" sm="4" md="4">
              <v-text-field
                v-model="certificado.applicant_destination"
                :rules="rules"
                label="Destino"
                required
                outlined
              ></v-text-field>
            </v-col>
          </template>
        </v-row>
        <v-row>
          <v-col cols="12" xs="12">
            <strong>El tamaño máximo es de 10 MB</strong>
            <client-only>
              <FilePond
                ref="filepondPDF"
                max-files="1"
                max-file-size="10MB"
                label-max-total-file-size-exceeded="El tamaño máximo es de 10 MB"
                allow-multiple="false"
                accepted-file-types="application/pdf"
                :label-idle="$t('uploadfile')"
                @updatefiles="updateFiles"
                @error="errorUpdateFiles"
              />
            </client-only>
          </v-col>
        </v-row>
      </v-card-text>
      <v-divider></v-divider>
      <v-card-actions class="px-5 my-3">
        <v-row justify="center">
          <v-btn id="cancelBtn" color="secondary" text @click="closeDialog()">
            {{ $t('cancel') }}
          </v-btn>
          <v-btn
            id="saveBtn"
            color="primary"
            text
            :disabled="!valid || files.length === 0"
            @click="save()"
          >
            {{ $t('send') }}
          </v-btn>
        </v-row>
      </v-card-actions>
    </v-card>
  </v-form>
</template>

<script lang="ts">
import Vue from 'vue'
import * as FilePond from 'filepond'
import FilePondPluginFileValidateSize from 'filepond-plugin-file-validate-size'
import { saveFile } from '~/services/Firebase'
import { setCertificate, CompleteCertificate } from '~/services/Certificates'

FilePond.registerPlugin(FilePondPluginFileValidateSize)

export default Vue.extend({
  name: 'MisionesBonosVerdesCerts',
  components: {},
  props: {},
  data: () => ({
    certificado: {
      code: '',
      correlative: '',
      year: '',
      body: '',
      technical_report: '',
      technical_report_year: '',
      disposition: '',
      date: '',
      office_department: '',
      municipality: '',
      section: '',
      chacra: '',
      apple: '',
      parcela: '',
      initiator_name: '',
      initiator_dni: '',
      kind_of_person: '',
      applicant_name: '',
      applicant_dni: '',
      applicant_caracter: '',
      applicant_destination: '',
      pdf: '',
    },
    loading: false,
    modalSelectDate: false,
    files: [] as any,
    valid: true,
    rules: [(v: any) => !!v || 'Este campo es requerido'],
    rulesNumber4: [
      (v: string) => (v && v.length <= 4) || 'Se permiten 4 dígitos.',
    ],
    rulesNumber3: [
      (v: string) => (v && v.length <= 3) || 'Se permiten 3 dígitos.',
    ],
    rulesNumber2: [
      (v: string) => (v && v.length <= 2) || 'Se permiten 2 dígitos.',
    ],
    rulesNumber1: [
      (v: string) => (v && v.length <= 1) || 'Se permite 1 dígito.',
    ],
    kindofperson: ['Física', 'Jurídica'],
  }),
  watch: {},
  methods: {
    errorUpdateFiles() {
      this.valid = false
    },
    updateFiles(files: any[]): any {
      this.files = files
      this.certificado.pdf = files.length > 0 ? files[0].file.name : ''
    },
    closeDialog(): any {
      this.clearData()
      this.$emit('closeDialog')
    },
    clearData(): any {
      this.certificado = {
        code: '',
        correlative: '',
        year: '',
        body: '',
        technical_report: '',
        technical_report_year: '',
        disposition: '',
        date: '',
        office_department: '',
        municipality: '',
        section: '',
        chacra: '',
        apple: '',
        parcela: '',
        initiator_name: '',
        initiator_dni: '',
        kind_of_person: '',
        applicant_name: '',
        applicant_dni: '',
        applicant_caracter: '',
        applicant_destination: '',
        pdf: '',
      }
      ;(
        this.$refs.filepondPDF as Vue & { removeFiles: () => boolean }
      ).removeFiles()
    },
    async save() {
      this.loading = true
      try {
        const finalCertficate = CompleteCertificate(
          this.certificado,
          this.$store
        )
        await setCertificate(this.$fire, finalCertficate, 'certificates')
        saveFile(this.$fireModule, this.files[0].file, 'pdf_certificates')
        this.$emit('save')
        this.$emit('messages', {
          error: false,
          message: 'Los datos fueron guardados.',
        })
      } catch {
        this.$emit('messages', {
          error: true,
          message:
            'Los datos no pudieron ser guardados. Por favor intenta nuevamente.',
        })
      }
      this.loading = false
      this.$emit('closeDialog')
    },
  },
})
</script>
